/*
 *심심해서 만든 총 특수능력 플러그인의 소리 관련 기능 파일
 */
#if defined _TGMsound_included
#endinput
#endif
#define _TGMsound_included

//소리파일의 경로와 소리 관련 상수에 대한 정의는 이곳에 온다

//소리 관련 변수는 여기로
new Float:nextsuithelpsound[MAXPLAYERS + 1];
new Handle:suithelpsoundreserve[MAXPLAYERS + 1];

//playsound함수가 인수로 받는 소리 종류
#define SOUNDTYPEGRENADE_LAUNCHER1 0
#define SOUNDTYPEEXPLODE 1
#define SOUNDTYPEROCKETFIRE1 2
#define SOUNDTYPEHEAL 3
#define SOUNDTYPENOHEAL 4
#define SOUNDTYPEMINEPUT 5
#define SOUNDTYPEMINEACT 6
#define SOUNDTYPESENSORFIRE 7
#define SOUNDTYPESENSORDEACTIVE 8
#define SOUNDTYPESENSORATTACH 9
#define SOUNDTYPEENERGYBALLCHARGE 10
#define SOUNDTYPEENERGYBALLFIRE 11
#define SOUNDTYPEENERGYBALLLOOP 12
#define SOUNDTYPEENERGYBALLEXPLOSION 13
#define SOUNDTYPEENERGYBALLBOUNCE 14
#define SOUNDTYPEENERGYBALLDISINTEGRATE 15

#define TOTALSOUND 41

//playentitysound와 stopentitysound 가 인수로 받는 소리
#define SOUNDGRENADE_LAUNCHER1 0
#define SOUNDEXPLODE3 1
#define SOUNDEXPLODE4 2
#define SOUNDEXPLODE5 3
#define SOUNDROCKETFIRE1 4
#define SOUNDROCKET1 5
#define SOUNDMEDSHOT4 6
#define SOUNDSMALLMEDKIT1 7
#define SOUNDMEDSHOTNO1 8
#define SOUNDMINEPUT 9
#define SOUNDMINEACT1 10
#define SOUNDMINEACT2 11
#define SOUNDMINEACT3 12
#define SOUNDMINEACT4 13
#define SOUNDMINEACT5 14
#define SOUNDMINEACT6 15
#define SOUNDSENSORFIRE 16
#define SOUNDSENSORACTIVE 17
#define SOUNDSENSORDEACTIVE 18
#define SOUNDSENSORATTACH 19
#define SOUNDNUKEREADY 20 //핵 킬스트릭 사운드
#define SOUNDNUKEDETECT 21 //핵 발사를 결정한 순간 나는 소리
#define SOUNDNUKEFIRE 22 //핵이 날아오기 전에 나는 경보음
#define SOUNDNUKEEXPLODE 23 //핵이 폭발할 때 나는 소리
#define SOUNDSUITNOAMMO 24 //슈트에 총알이 없을때 난다
#define SOUNDSUITNOENERGY 25 //슈트에 에너지가 없을 때 난다
#define SOUNDSUITBLOODLOSS 26 //체력이 일정 이하일때 나는 소리, 출혈, 80이상
#define SOUNDSUITHEALTHDROP1 27 //체력이 일정 이하일때 나는 소리, 체력저하, 60이상
#define SOUNDSUITHEALTHDROP2 28 //체력이 일정 이하일때 나는 소리, 체력저하심함, 40이상
#define SOUNDSUITHEALTHCRITICAL 29 //체력이 일정 이하일때 나는 소리, 치명적체력저하, 20이상
#define SOUNDSUITNEARDEATH 30 //체력이 일정 이하일때 나는 소리, 사망 임박, 20미만
#define SOUNDSUITFINEMEDIC 31 //의사 찾기 권유
#define SOUNDSUITDEATH 32 //사망
#define SOUNDENERGYBALLCHARGE 33 //에너지볼 발사 대기
#define SOUNDENERGYBALLFIRE 34 //에너지볼 발사
#define SOUNDENERGYBALLLOOP 35 //에너지볼 반복음
#define SOUNDENERGYBALLEXPLOSION 36 //에너지볼 폭발
#define SOUNDENERGYBALLBOUNCE1 37 //에너지볼 튕김 1
#define SOUNDENERGYBALLBOUNCE2 38 //에너지볼 튕김 2
#define SOUNDENERGYBALLDISINTEGRATE1 39 //에너지볼 공격 2
#define SOUNDENERGYBALLDISINTEGRATE2 40 //에너지볼 공격 2

new String:sounddata[TOTALSOUND][128] = {
	
	{"weapons/grenade_launcher1.wav"},
	{"weapons/explode3.wav"},
	{"weapons/explode3.wav"},
	{"weapons/explode3.wav"},
	{"weapons/rpg/rocketfire1.wav"},
	{"weapons/rpg/rocket1.wav"},
	{"items/medshot4.wav"},
	{"items/smallmedkit1.wav"},
	{"items/medshotno1.wav"},
	{"weapons/slam/mine_mode.wav"},
	{"npc/roller/mine/rmine_blades_out1.wav"},
	{"npc/roller/mine/rmine_blades_out2.wav"},
	{"npc/roller/mine/rmine_blades_out3.wav"},
	{"npc/roller/mine/rmine_blades_in1.wav"},
	{"npc/roller/mine/rmine_blades_in2.wav"},
	{"npc/roller/mine/rmine_blades_in3.wav"},
	{"npc/roller/mine/rmine_chirp_answer1.wav"},
	{"npc/roller/mine/rmine_seek_loop2.wav"},
	{"npc/roller/mine/combine_mine_deploy1.wav"},
	{"npc/scanner/cbot_servochatter.wav"},
	{"Tactical_Nuke/1.wav"},//이것이 핵 킬스트릭 소리
	{"Tactical_Nuke/2.wav"},//이것이 핵 발사 위치 지정시의 소리
	{"Tactical_Nuke/3-1.wav"},//이것이 핵 날아오기 전 경보 소리
	{"Tactical_Nuke/4-1.wav"},//이것이 핵 폭발 소리
	{"hl1/fvox/ammo_depleted.wav"},//슈트에 총알 없을때
	{"hl1/fvox/armor_gone.wav"},//슈트에 에너지 없을 때
	{"hl1/fvox/blood_loss.wav"},//체력이 일정 이하일때 나는 소리, 출혈, 80이상
	{"hl1/fvox/health_dropping2.wav"},//체력이 일정 이하일때 나는 소리, 체력저하, 60이상
	{"hl1/fvox/health_dropping.wav"},//체력이 일정 이하일때 나는 소리, 체력저하심함, 40이상
	{"hl1/fvox/health_critical.wav"},//체력이 일정 이하일때 나는 소리, 치명적체력저하, 20이상
	{"hl1/fvox/near_death.wav"},//체력이 일정 이하일때 나는 소리, 사망 임박, 20미만
	{"hl1/fvox/seek_medic.wav"},//의사 찾기 권유
	{"hl1/fvox/flatline.wav"},//사망
	{"weapons/cguard/charging.wav"},//에너지볼 발사 대기
	{"weapons/irifle/irifle_fire2.wav"},//에너지볼 발사
	{"weapons/physcannon/energy_sing_loop4.wav"},//에너지볼 반복음
	{"weapons/physcannon/energy_sing_explosion2.wav"},//에너지볼 폭발
	{"weapons/physcannon/energy_bounce1.wav"},//에너지볼 튕김1
	{"weapons/physcannon/energy_bounce2.wav"},//에너지볼 튕김2
	{"weapons/physcannon/energy_disintegrate4.wav"},//에너지볼 공격1
	{"weapons/physcannon/energy_disintegrate5.wav"}//에너지볼 공격 2
	
};

//함수들
stock prepatchsounds(){
	
	// decl String:txt[256];
	//Format(txt, 256, "sound/%s", sounddata[SOUNDNUKEREADY]);
	// AddFileToDownloadsTable(txt);
	//Format(txt, 256, "sound/%s", sounddata[SOUNDNUKEDETECT]);
	// AddFileToDownloadsTable(txt);
	//Format(txt, 256, "sound/%s", sounddata[SOUNDNUKEFIRE]);
	// AddFileToDownloadsTable(txt);
	//Format(txt, 256, "sound/%s", sounddata[SOUNDNUKEEXPLODE]);
	// AddFileToDownloadsTable(txt);
	
	//소리 프리패치, 쓰이는 모든 소리를 프리패치한다
	for(new i = 0; i < TOTALSOUND; i++){
		
		PrecacheSound(sounddata[i], true);
		
	}
	
}

//한 장소에서 사운드를 한번 재생하는 함수, 어떤 엔티티에서 나는 소리인지는 정할 수 없고,
//소리는 소리파일에 반복설정이 있지 않는 한 반복되지 않는다
stock playsound(entity = SOUND_FROM_WORLD, soundtype, Float:soundposition[3]){
	
	if(soundtype == SOUNDTYPEGRENADE_LAUNCHER1){
		
		EmitSoundToAll(sounddata[SOUNDGRENADE_LAUNCHER1], entity, SNDCHAN_AUTO, SNDLEVEL_NORMAL, SND_NOFLAGS, SNDVOL_NORMAL, SNDPITCH_NORMAL, -1, soundposition, NULL_VECTOR, true, 0.0);
		
	}else if(soundtype == SOUNDTYPEEXPLODE){
		
		EmitSoundToAll(sounddata[GetRandomInt(SOUNDEXPLODE3, SOUNDEXPLODE5)], entity, SNDCHAN_AUTO, SNDLEVEL_NORMAL, SND_NOFLAGS, SNDVOL_NORMAL, SNDPITCH_NORMAL, -1, soundposition, NULL_VECTOR, true, 0.0);
		
	}else if(soundtype == SOUNDTYPEROCKETFIRE1){
		
		EmitSoundToAll(sounddata[SOUNDROCKETFIRE1], entity, SNDCHAN_AUTO, SNDLEVEL_NORMAL, SND_NOFLAGS, SNDVOL_NORMAL, SNDPITCH_NORMAL, -1, soundposition, NULL_VECTOR, true, 0.0);
		
	}else if(soundtype == SOUNDTYPEHEAL){
		
		EmitSoundToAll(sounddata[GetRandomInt(SOUNDMEDSHOT4, SOUNDSMALLMEDKIT1)], entity, SNDCHAN_AUTO, SNDLEVEL_NORMAL, SND_NOFLAGS, SNDVOL_NORMAL, SNDPITCH_NORMAL, -1, soundposition, NULL_VECTOR, true, 0.0);
		
	}else if(soundtype == SOUNDTYPENOHEAL){
		
		EmitSoundToAll(sounddata[SOUNDMEDSHOTNO1], entity, SNDCHAN_AUTO, SNDLEVEL_NORMAL, SND_NOFLAGS, SNDVOL_NORMAL, SNDPITCH_NORMAL, -1, soundposition, NULL_VECTOR, true, 0.0);
		
	}else if(soundtype == SOUNDTYPEMINEPUT){
		
		EmitSoundToAll(sounddata[SOUNDMINEPUT], entity, SNDCHAN_AUTO, SNDLEVEL_NORMAL, SND_NOFLAGS, SNDVOL_NORMAL, SNDPITCH_NORMAL, -1, soundposition, NULL_VECTOR, true, 0.0);
		
	}else if(soundtype == SOUNDTYPEMINEACT){
		
		EmitSoundToAll(sounddata[GetRandomInt(SOUNDMINEACT1, SOUNDMINEACT6)], entity, SNDCHAN_AUTO, SNDLEVEL_NORMAL, SND_NOFLAGS, SNDVOL_NORMAL, SNDPITCH_NORMAL, -1, soundposition, NULL_VECTOR, true, 0.0);
		
	}else if(soundtype == SOUNDTYPESENSORFIRE){
		
		EmitSoundToAll(sounddata[SOUNDSENSORFIRE], entity, SNDCHAN_AUTO, SNDLEVEL_NORMAL, SND_NOFLAGS, SNDVOL_NORMAL, SNDPITCH_NORMAL, -1, soundposition, NULL_VECTOR, true, 0.0);
		
	}else if(soundtype == SOUNDTYPESENSORDEACTIVE){
		
		EmitSoundToAll(sounddata[SOUNDSENSORDEACTIVE], entity, SNDCHAN_AUTO, SNDLEVEL_NORMAL, SND_NOFLAGS, SNDVOL_NORMAL, SNDPITCH_NORMAL, -1, soundposition, NULL_VECTOR, true, 0.0);
		
	}else if(soundtype == SOUNDTYPESENSORATTACH){
		
		EmitSoundToAll(sounddata[SOUNDSENSORATTACH], entity, SNDCHAN_AUTO, SNDLEVEL_NORMAL, SND_NOFLAGS, SNDVOL_NORMAL, SNDPITCH_NORMAL, -1, soundposition, NULL_VECTOR, true, 0.0);
		
	}else if(soundtype == SOUNDTYPEENERGYBALLCHARGE){
		
		EmitSoundToAll(sounddata[SOUNDENERGYBALLCHARGE], entity, SNDCHAN_AUTO, SNDLEVEL_NORMAL, SND_NOFLAGS, SNDVOL_NORMAL, SNDPITCH_NORMAL, -1, soundposition, NULL_VECTOR, true, 0.0);
		
	}else if(soundtype == SOUNDTYPEENERGYBALLFIRE){
		
		EmitSoundToAll(sounddata[SOUNDENERGYBALLFIRE], entity, SNDCHAN_AUTO, SNDLEVEL_NORMAL, SND_NOFLAGS, SNDVOL_NORMAL, SNDPITCH_NORMAL, -1, soundposition, NULL_VECTOR, true, 0.0);
		
	}else if(soundtype == SOUNDTYPEENERGYBALLLOOP){
		
		EmitSoundToAll(sounddata[SOUNDENERGYBALLLOOP], entity, SNDCHAN_AUTO, SNDLEVEL_NORMAL, SND_NOFLAGS, SNDVOL_NORMAL, SNDPITCH_NORMAL, -1, soundposition, NULL_VECTOR, true, 0.0);
		
	}else if(soundtype == SOUNDTYPEENERGYBALLEXPLOSION){
		
		EmitSoundToAll(sounddata[SOUNDENERGYBALLEXPLOSION], entity, SNDCHAN_AUTO, SNDLEVEL_NORMAL, SND_NOFLAGS, SNDVOL_NORMAL, SNDPITCH_NORMAL, -1, soundposition, NULL_VECTOR, true, 0.0);
		
	}else if(soundtype == SOUNDTYPEENERGYBALLBOUNCE){
		
		EmitSoundToAll(sounddata[GetRandomInt(SOUNDENERGYBALLBOUNCE1, SOUNDENERGYBALLBOUNCE2)], entity, SNDCHAN_AUTO, SNDLEVEL_NORMAL, SND_NOFLAGS, SNDVOL_NORMAL, SNDPITCH_NORMAL, -1, soundposition, NULL_VECTOR, true, 0.0);
		
	}else if(soundtype == SOUNDTYPEENERGYBALLDISINTEGRATE){
		
		EmitSoundToAll(sounddata[GetRandomInt(SOUNDENERGYBALLDISINTEGRATE1, SOUNDENERGYBALLDISINTEGRATE2)], entity, SNDCHAN_AUTO, SNDLEVEL_NORMAL, SND_NOFLAGS, SNDVOL_NORMAL, SNDPITCH_NORMAL, -1, soundposition, NULL_VECTOR, true, 0.0);
		
	}
	
}

//소리를 재생하는 엔티티를 지정하는 함수, 지정된 엔티티의 위치가 바뀜에 따라 소리도 자동으로 따라가며, 소리파일에 반복플래그가 있는 경우 수동으로 멈추기 전까지 계속 반복된다
stock playentitysound(entity, sound, Float:soundposition[3]){
	
	EmitSoundToAll(sounddata[sound], entity, SNDCHAN_AUTO, SNDLEVEL_NORMAL, SND_NOFLAGS, 1.0, SNDPITCH_NORMAL, -1, soundposition);
	
}

//playentitysound 함수로 재생한 소리는 이 함수를 써서 멈춰야 한다
stock stopentitysound(entity, sound){
	
	StopSound(entity, SNDCHAN_AUTO, sounddata[sound]);
	
}

stock playsoundfromclient(client, sound){
	
	EmitSoundToClient(client, sounddata[sound]);
	
}

stock playsoundfromallclient(sound){
	
	for(new i = 1; i <= MaxClients; i++){
			
		if(isClientConnectedIngame(i))playsoundfromclient(i, sound);
		
	}
		
}

stock playsuithelpsound(client, sound, bool:alwaysplay = false){
	
	if(isClientConnectedIngame(client)){
		
		new Float:nowtime = GetGameTime();
		
		if((nextsuithelpsound[client] <= nowtime) || alwaysplay){
			
			if(isteamsuitsoundenable(GetClientTeam(client))){
				
				nextsuithelpsound[client] = nowtime + TGMSUITHELPSOUNDDELAY;
				
				playsoundfromclient(client, sound);
				
			}
			
		}
		
	}
	
}

stock reservesuithelpsound(Float:time, client, sound, bool:alwaysplay = false){
	
	if(isClientConnectedIngame(client)){
		
		cancelreservesuithelpsound(client);
		
		new Handle:datapack = CreateDataPack();
		WritePackCell(datapack, GetClientUserId(client));
		WritePackCell(datapack, client);
		WritePackCell(datapack, sound);
		
		if(alwaysplay){
			
			WritePackCell(datapack, 1);
			
		}else{
			
			WritePackCell(datapack, 0);
			
		}
		
		suithelpsoundreserve[client] = CreateTimer(time, timersuithelpsound, datapack);
		
	}
	
}

stock cancelreservesuithelpsound(client){
	
	if(suithelpsoundreserve[client] != INVALID_HANDLE){
		
		KillTimer(suithelpsoundreserve[client], true);
		suithelpsoundreserve[client] = INVALID_HANDLE;
		
	}
	
}

public Action:timersuithelpsound(Handle:timer, Handle:datapack){
	
	decl userid, oldclient, client, sound, bool:alwaysplay;
	
	ResetPack(datapack);
	
	userid = ReadPackCell(datapack);
	oldclient = ReadPackCell(datapack);
	client = GetClientOfUserId(userid);
	sound = ReadPackCell(datapack);
	
	suithelpsoundreserve[oldclient] = INVALID_HANDLE;
	
	if(ReadPackCell(datapack) == 1){
		
		alwaysplay = true;
		
	}else{
		
		alwaysplay = false;
		
	}
	
	CloseHandle(datapack);
	
	if(isClientConnectedIngame(client)){
		
		if(isteamsuitsoundenable(GetClientTeam(client))){
		
			new Float:nowtime = GetGameTime();
			
			if((nextsuithelpsound[client] <= nowtime) || alwaysplay){
				
				nextsuithelpsound[client] = nowtime + TGMSUITHELPSOUNDDELAY;
				
				playsoundfromclient(client, sound);
				
			}
			
		}
			
	}
	
}